"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const hard_cidr_1 = require("@sophosoft/hard-cidr");
class VpcCidr {
    constructor(cidrBlock, azList, zoneAdditionalBits = 2, subnetAdditionalBits = [1, 1, 1, 0]) {
        this.cidrBlock = cidrBlock;
        this.azList = azList;
        this.dataBlocks = [];
        this.externalBlocks = [];
        this.internalBlocks = [];
        this.networkBlocks = [];
        const zoneBlocks = azList.map((zone, i) => {
            return { zone, cidr: hard_cidr_1.cidrsubnet(cidrBlock, zoneAdditionalBits, i) };
        });
        zoneBlocks.map((block) => {
            const subnetBlocks = hard_cidr_1.cidrsubnets(block.cidr, subnetAdditionalBits);
            this.dataBlocks.push({ zone: block.zone, type: "data", cidr: subnetBlocks[2] });
            this.externalBlocks.push({ zone: block.zone, type: "external", cidr: subnetBlocks[1] });
            this.internalBlocks.push({ zone: block.zone, type: "internal", cidr: subnetBlocks[0] });
            this.networkBlocks.push({ zone: block.zone, type: "network", cidr: subnetBlocks[3] });
        });
    }
}
exports.VpcCidr = VpcCidr;
