"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi_1 = require("@pulumi/pulumi");
const route53_1 = require("@pulumi/aws/route53");
const ec2_1 = require("@pulumi/aws/ec2");
class VpcDns extends pulumi_1.ComponentResource {
    constructor(name, options, extra) {
        super('sophosoft:aws:VpcDns', name, {}, extra);
        this.zone = new route53_1.Zone(`${name}-zone`, {
            vpcs: [{
                    vpcId: options.vpcId,
                    vpcRegion: options.region
                }],
            name: options.domainName
        }, Object.assign(Object.assign({}, extra), { parent: this }));
        this.dhcp = new ec2_1.VpcDhcpOptions(`${name}-dhcp`, {
            domainName: options.domainName,
            domainNameServers: options.nameServers || ['AmazonProvidedDNS'],
            tags: {
                Name: `${options.prefix}-dhcp`
            }
        }, Object.assign(Object.assign({}, extra), { parent: this }));
        this.association = new ec2_1.VpcDhcpOptionsAssociation(`${name}-dhcp`, {
            dhcpOptionsId: this.dhcp.id,
            vpcId: options.vpcId
        }, Object.assign(Object.assign({}, extra), { parent: this }));
    }
}
exports.VpcDns = VpcDns;
