"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi_1 = require("@pulumi/pulumi");
const ec2_1 = require("@pulumi/aws/ec2");
class VpcNat extends pulumi_1.ComponentResource {
    constructor(name, options, extra) {
        super('sophosoft:aws:VpcNat', name, {}, extra);
        this.eip = new ec2_1.Eip(`${name}-eip`, {
            vpc: true,
            tags: {
                Name: `${options.namePrefix}-eip-${options.azLetter}`
            }
        }, Object.assign(Object.assign({}, extra), { parent: this }));
        this.nat = new ec2_1.NatGateway(`${name}-nat`, {
            allocationId: this.eip.id,
            subnetId: options.subnetId,
            tags: {
                Name: `${options.namePrefix}-nat-${options.azLetter}`
            }
        }, Object.assign(Object.assign({}, extra), { parent: this }));
        this.routes = new ec2_1.RouteTable(`${name}-routes`, {
            vpcId: options.vpcId,
            routes: [{
                    cidrBlock: '0.0.0.0/0',
                    natGatewayId: this.nat.id
                }],
            tags: {
                Name: `${options.namePrefix}-internal-${options.azLetter}`
            }
        }, Object.assign(Object.assign({}, extra), { parent: this }));
    }
}
exports.VpcNat = VpcNat;
