import { ComponentResource, Input, ComponentResourceOptions } from "@pulumi/pulumi";
import { Subnet, RouteTableAssociation } from "@pulumi/aws/ec2";
export declare type VpcSubnetType = 'internal' | 'external' | 'data' | 'network';
export interface VpcSubnetOptions {
    vpcId: string | Input<string>;
    availabilityZone: string;
    cidrBlock: string;
    namePrefix: string;
    type: VpcSubnetType;
    routeTableId?: string | Input<string>;
}
export declare class VpcSubnet extends ComponentResource {
    readonly subnet: Subnet;
    readonly association?: RouteTableAssociation;
    constructor(name: string, options: VpcSubnetOptions, extra?: ComponentResourceOptions);
}
