"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi_1 = require("@pulumi/pulumi");
const ec2_1 = require("@pulumi/aws/ec2");
class VpcSubnet extends pulumi_1.ComponentResource {
    constructor(name, options, extra) {
        super('sophosoft:aws:VpcSubnet', name, {}, extra);
        const zoneLetter = options.availabilityZone[options.availabilityZone.length - 1];
        this.subnet = new ec2_1.Subnet(`${name}-subnet`, {
            vpcId: options.vpcId,
            availabilityZone: options.availabilityZone,
            mapPublicIpOnLaunch: (options.type === 'external'),
            cidrBlock: options.cidrBlock,
            tags: {
                Name: `${options.namePrefix}-${options.type}-${zoneLetter}`
            }
        }, Object.assign(Object.assign({}, extra), { parent: this }));
        if (options.routeTableId !== undefined) {
            this.association = new ec2_1.RouteTableAssociation(`${name}-rta`, {
                routeTableId: options.routeTableId,
                subnetId: this.subnet.id
            }, Object.assign(Object.assign({}, extra), { parent: this }));
        }
    }
}
exports.VpcSubnet = VpcSubnet;
